<?php

namespace Teknisa\SM\Controller;

use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use Teknisa\SM\Service\ApiPropostaService;

class ApiPropostaController {
    
    protected $apiPropostaService;
    
    public function __construct(ApiPropostaService $apiPropostaService) {
        $this->apiPropostaService = $apiPropostaService;
    }
    
    public function inserirProposta(Request\Row $request, Response $response) {
        try {
            $row = $request->getRow();
            $cliente      = $row["cliente"];
            $interlocutor = $row["interlocutor"];
            $proposta     = $row["proposta"];
            $cdoperador   = $row["requisitante"]["cdoperador"];
            $nrorg        = $row["requisitante"]["nrorg"];
            
            $nrseqorcamento = $this->apiPropostaService->inserirPropostaApi($cliente, $interlocutor, $proposta, $cdoperador, $nrorg);
            $response->addDataSet(new DataSet("proposta", array("id" => $nrseqorcamento)));
        }
        catch (\Exception $e) {
            $response->setError(new Response\Error($e->getMessage(), $e->getCode()));
        }
    }
}

?>